module code.devicecalculus.BitPatterns where

open import Data.Maybe
open import Data.Vec 

open import code.common.Idioms
open import code.common.MachineWords renaming (zero to machine0)

---
--- Pattern-matching constructs
---

data BitPat : Set where
   ⓪ : BitPat
   ① : BitPat
   ⊛ : BitPat

match : ∀ {n} → Vec BitPat n → Vec Bit n → Maybe (Vec Bit n)
match [] []     = just []
match (⓪ ∷ tp) (0# ∷ t) = case (match tp t) of
                            λ { (just t') → just (0# ∷ t')
                              ; nothing   → nothing
                              }
match (⓪ ∷ tp) (1# ∷ t) = nothing
match (① ∷ tp) (1# ∷ t) = case (match tp t) of
                            λ { (just t') → just (0# ∷ t')
                              ; nothing   → nothing
                              }
match (① ∷ tp) (0# ∷ t) = nothing
match (⊛ ∷ tp) (b ∷ t)   = case (match tp t) of
                             λ { (just t') → just (b ∷ t')
                               ; nothing   → nothing
                               }

_$_,_ : ∀ {ℓ} {a b : Set ℓ} → (a → b) → Maybe a → b → b
f $ nothing , b  = b
f $ (just a) , _ = f a
