module code.firrtl.Equivalence where

-- This is the proposed equivalence theorem stated in Agda

open import Relation.Binary.PropositionalEquality hiding ([_])

open import Data.Bool renaming (Bool to Bit; false to 0#; true to 1#)
open import Data.Fin using (Fin; zero; suc)
open import Data.List hiding (lookup ; [_])
open import Data.Maybe hiding (map)
open import Data.Nat using (ℕ; _∸_; _<_ ; _≤_ ; _+_) renaming (zero to Z; suc to S)
open import Data.Product hiding (map ; swap ; curry ; uncurry)
open import Data.Vec hiding (foldl ; foldr ; _++_ ; map ; _[_]=_ ; length ; count) renaming (lookup to vecref)

open import code.common.Idioms hiding (π³⁴ ; π⁴⁴)
open import code.common.Contexts

open import code.firrtl.Types
open import code.firrtl.Syntax
open import code.firrtl.TransType
open import code.firrtl.TransCircuit

open import code.devicecalculus.Types
open import code.devicecalculus.BitPatterns
open import code.devicecalculus.Syntax hiding (⟨_⟩)
open import code.devicecalculus.MealyMachine
open import code.devicecalculus.Semantics

open Mealy

i⟨_⟩ : ModTy → Set
i⟨ Δ ⟩ = Value (inputs Δ)
s⟨_⟩ : ModTy → Set
s⟨ Δ ⟩ = Value (registers Δ)
o⟨_⟩ : ModTy → Set
o⟨ Δ ⟩ = Value (outputs Δ)

step : ∀ (Δ : ModTy)
       → (c : [] ⊢ᶜ Δ)
       → (i⟨ Δ ⟩ × s⟨ Δ ⟩ × o⟨ Δ ⟩)
       → i⟨ Δ ⟩
       → (i⟨ Δ ⟩ × s⟨ Δ ⟩ × o⟨ Δ ⟩)
step Δ c (i,s,o) i' = {!!}

circuit : ∀ (Δ : ModTy)
        → (c : [] ⊢ᶜ Δ)
        → Mealy i⟨ Δ ⟩ s⟨ Δ ⟩ o⟨ Δ ⟩ 
circuit Δ c = ⟦ trC Δ [] c ⟧ []

equivalence : ∀ (Δ : ModTy)
            → (c : [] ⊢ᶜ Δ)
            → (i : i⟨ Δ ⟩)
            → step Δ c (now (circuit Δ c)) i ≡ now (nxt (circuit Δ c) i)
equivalence Δ c = {!!}
